## custom-toolbox 25.08.4

=== CMakeLists.txt ===
# **********************************************************************
# * Copyright (C) 2017-2025 MX Authors
# *
# * Authors: Adrian
# *          MX Linux <http://mxlinux.org>
# *
# * This file is part of custom-toolbox.
# *
# * custom-toolbox is free software: you can redistribute it and/or modify
# * it under the terms of the GNU General Public License as published by
# * the Free Software Foundation, either version 3 of the License, or
# * (at your option) any later version.
# *
# * custom-toolbox is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# * GNU General Public License for more details.
# *
# * You should have received a copy of the GNU General Public License
# * along with custom-toolbox.  If not, see <http://www.gnu.org/licenses/>.
# **********************************************************************/

cmake_minimum_required(VERSION 3.16)

# Get version from debian/changelog
execute_process(
    COMMAND dpkg-parsechangelog -SVersion
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
    OUTPUT_VARIABLE PROJECT_VERSION_FROM_CHANGELOG
    OUTPUT_STRIP_TRAILING_WHITESPACE
    RESULT_VARIABLE DPKG_RESULT
)

if(NOT DPKG_RESULT EQUAL 0)
    message(FATAL_ERROR "Failed to get version from debian/changelog using dpkg-parsechangelog")
endif()

project(custom-toolbox
    VERSION ${PROJECT_VERSION_FROM_CHANGELOG}
    DESCRIPTION "Custom Toolbox - Program for creating custom launchers for MX Linux"
    LANGUAGES CXX
)

# Set C++ standard
set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# Enable compile commands export for IDEs and tools
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

# Optimize for Ninja builds
if(CMAKE_GENERATOR STREQUAL "Ninja")
    # Enable colored output for Ninja
    if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
        add_compile_options(-fdiagnostics-color=always)
    elseif(CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
        add_compile_options(-fcolor-diagnostics)
    endif()
endif()

# Option to use clang for testing builds
option(USE_CLANG "Use clang compiler" OFF)
if(USE_CLANG)
    set(CMAKE_C_COMPILER clang)
    set(CMAKE_CXX_COMPILER clang++)
    set(CMAKE_CXX_COMPILER_ID "Clang")
    message(STATUS "Using clang compiler")
endif()

# Find Qt6 components
find_package(Qt6 REQUIRED COMPONENTS
    Core
    Gui
    Widgets
    LinguistTools
)

# Enable automatic MOC, UIC, and RCC processing
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)

# Define source files
set(SOURCES
    src/main.cpp
    src/mainwindow.cpp
    src/flatbutton.cpp
    src/about.cpp
)

set(HEADERS
    src/mainwindow.h
    src/flatbutton.h
    src/about.h
    src/common.h
)

set(UI_FILES
    src/mainwindow.ui
)

set(RESOURCE_FILES
    images.qrc
)

# Get all translation files
file(GLOB TRANSLATION_FILES "translations/*.ts")

# Create the executable
add_executable(custom-toolbox
    ${SOURCES}
    ${HEADERS}
    ${UI_FILES}
    ${RESOURCE_FILES}
)

# Link Qt6 libraries
target_link_libraries(custom-toolbox
    Qt6::Core
    Qt6::Gui
    Qt6::Widgets
)

# Set compiler flags
target_compile_options(custom-toolbox PRIVATE
    -Wpedantic
    -pedantic
    -Werror=return-type
    -Werror=switch
    -Werror=uninitialized
    -Werror
)

# Add compiler-specific flags
if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang" OR USE_CLANG)
    target_compile_options(custom-toolbox PRIVATE -Werror=return-stack-address)
else()
    target_compile_options(custom-toolbox PRIVATE -Werror=return-local-addr)
endif()

# Set compile definitions
target_compile_definitions(custom-toolbox PRIVATE
    QT_DEPRECATED_WARNINGS
    QT_DISABLE_DEPRECATED_BEFORE=0x060000
)

# Release-specific optimizations
if(CMAKE_BUILD_TYPE STREQUAL "Release")
    target_compile_definitions(custom-toolbox PRIVATE NDEBUG)
    target_compile_options(custom-toolbox PRIVATE -O3)

    # Add LTO - different flags for different compilers
    if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang" OR USE_CLANG)
        target_compile_options(custom-toolbox PRIVATE -flto=thin)
        target_link_options(custom-toolbox PRIVATE -flto=thin)
    else()
        target_compile_options(custom-toolbox PRIVATE -flto=auto)
        target_link_options(custom-toolbox PRIVATE -flto=auto)
    endif()
endif()

# Handle translations
qt6_add_translations(custom-toolbox
    TS_FILES ${TRANSLATION_FILES}
    QM_FILES_OUTPUT_VARIABLE qm_files
)

# Generate version.h file
configure_file(
    "${CMAKE_SOURCE_DIR}/src/version.h.in"
    "${CMAKE_BINARY_DIR}/src/version.h"
    @ONLY
)

# Set target properties
set_target_properties(custom-toolbox PROPERTIES
    OUTPUT_NAME "custom-toolbox"
    RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}
)

# Add build directory to include path for generated version.h
target_include_directories(custom-toolbox PRIVATE ${CMAKE_BINARY_DIR}/src)

# Install target (required by Debian build system)
# Other files are handled by debian/install
install(TARGETS custom-toolbox
    RUNTIME DESTINATION bin
)

## custom-toolbox 0.18.9

=== debian/changelog ===
custom-toolbox (0.18.9) mx; urgency=medium

  * change how default editor is picked up

 -- Adrian <adrian@mxlinux.org>  Mon, 17 Sep 2018 15:27:22 -0400

custom-toolbox (0.18.6.1) mx; urgency=medium

  * added changelog
  * increased icon sizes
  * default focus on search
  * use libcmd

 -- Adrian <adrian@mxlinux.org>  Sun, 24 Jun 2018 08:37:29 -0400

custom-toolbox (0.18.6) mx; urgency=medium

  * minor change in getVersion()

 -- Adrian <adrian@mxlinux.org>  Thu, 21 Jun 2018 21:25:02 -0400

custom-toolbox (0.18.3) mx; urgency=medium

  * generalized text editor

 -- Adrian <adrian@mxlinux.org>  Mon, 19 Mar 2018 12:01:52 -0400

custom-toolbox (0.17.10) mx; urgency=medium

  * update icon

 -- Adrian <adrian@mxlinux.org>  Tue, 31 Oct 2017 13:11:20 -0400

custom-toolbox (0.17.5) mx; urgency=medium

  * update icons

 -- Adrian <adrian@mxlinux.org>  Fri, 12 May 2017 12:59:15 -0400

custom-toolbox (0.17.2+1) mx; urgency=medium

  * bug fixes

 -- Adrian <adrian@mxlinux.org>  Fri, 17 Feb 2017 11:00:49 -0500

custom-toolbox (0.17.2) mx; urgency=medium

  * updates

 -- Adrian <adrian@mxlinux.org>  Mon, 06 Feb 2017 10:36:32 -0500

custom-toolbox (0.17.1) mx; urgency=medium

  * initial release

 -- Adrian <adrian@mxlinux.org>  Wed, 18 Jan 2017 19:44:43 -0500

=== debian/control ===
Source: custom-toolbox
Section: admin
Priority: optional
Maintainer: Adrian <adrian@mxlinux.org>
Build-Depends: qt5-qmake,
        qt5-default,
        qttools5-dev-tools,
	debhelper (>=9),
	libcmd
Standards-Version: 3.9.8
Vcs-Git: git://github.com/AdrianTM/custom-toolbox

Package: custom-toolbox
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, gksu
Description: Custom Toolbox
 Custom Toolbox is a tool used for creating collections of icons

=== debian/rules ===
#!/usr/bin/make -f

QMAKE_OPTS = DEFINES+=NO_DEBUG_ON_CONSOLE
MAKE_OPTS  = QMAKE=qmake-qt5 LRELEASE=lrelease-qt5 QMAKE_OPTS="$(QMAKE_OPTS)"

override_dh_auto_clean:
	dh_auto_clean
	rm -f src/translations/*.qm

override_dh_auto_build:
	lupdate custom-toolbox.pro
	lrelease custom-toolbox.pro
	dh_auto_build -- $(MAKE_OPTS)

override_dh_auto_install:
	dh_auto_install -- $(MAKE_OPTS)

override_dh_builddeb:
	dh_builddeb -- -Z xz

override_dh_shlibdeps:
	dh_shlibdeps --dpkg-shlibdeps-params=--ignore-missing-info

%:
	dh $@ --parallel

## custom-toolbox 0.19.9

=== debian/changelog ===
custom-toolbox (0.19.9) mx; urgency=medium

  * remove libcmd dependency

 -- Adrian <adrian@mxlinux.org>  Wed, 11 Sep 2019 13:36:54 -0400

=== debian/control ===
Source: custom-toolbox
Section: admin
Priority: optional
Maintainer: Adrian <adrian@mxlinux.org>
Build-Depends: debhelper (>=9), qtbase5-dev, qttools5-dev-tools
Standards-Version: 3.9.8
Vcs-Git: git://github.com/AdrianTM/custom-toolbox

Package: custom-toolbox
Architecture: any
Depends: gksu, ${misc:Depends}, ${shlibs:Depends}
Description: Custom Toolbox
 Custom Toolbox is a tool used for creating collections of icons

## custom-toolbox 0.20.1

=== debian/changelog ===
custom-toolbox (0.20.1) mx; urgency=medium

  * help.html update

 -- Adrian <adrian@mxlinux.org>  Mon, 06 Jan 2020 17:11:16 -0500

## custom-toolbox 0.20.4

=== debian/changelog ===
custom-toolbox (0.20.4) mx; urgency=medium

  * replaced gksudo with mx-pkexec

 -- Adrian <adrian@mxlinux.org>  Thu, 23 Apr 2020 16:54:02 -0400

## custom-toolbox 0.20.9

=== debian/changelog ===
custom-toolbox (0.20.9) mx; urgency=medium

  * can add terminal applications that don't have a .desktop file
  * launch applications in background and detached
  * remove extra dialog if canceling file selection
  * make maximum number of columns customizeable in custom-toolbox.conf: max_col=3 for example

 -- Adrian <adrian@mxlinux.org>  Fri, 04 Sep 2020 12:11:49 -0400

## custom-toolbox 0.20.9.2

=== debian/changelog ===
custom-toolbox (0.20.9.2) mx; urgency=medium

  * fix launching programs 

 -- Adrian <adrian@mxlinux.org>  Fri, 04 Sep 2020 17:35:40 -0400

custom-toolbox (0.20.9.1) mx; urgency=medium

  * try first to display icon for application, if not find display terminal icon

 -- Adrian <adrian@mxlinux.org>  Fri, 04 Sep 2020 16:21:34 -0400

## custom-toolbox 0.20.9.3

=== debian/changelog ===
custom-toolbox (0.20.9.3) mx; urgency=medium

  * use full path for icon

 -- Adrian <adrian@mxlinux.org>  Sat, 05 Sep 2020 15:13:59 -0400

## custom-toolbox 0.20.9.4

=== debian/changelog ===
custom-toolbox (0.20.9.4) mx; urgency=medium

  * update icon

 -- Adrian <adrian@mxlinux.org>  Mon, 07 Sep 2020 09:30:15 -0400

=== debian/control ===
--- 
+++ 
@@ -8,6 +8,6 @@
 
 Package: custom-toolbox
 Architecture: any
-Depends: gksu, ${misc:Depends}, ${shlibs:Depends}
+Depends: mx-pkexec, ${misc:Depends}, ${shlibs:Depends}
 Description: Custom Toolbox
  Custom Toolbox is a tool used for creating collections of icons

=== debian/rules ===
--- 
+++ 
@@ -1,4 +1,5 @@
 #!/usr/bin/make -f
+export QT_SELECT=5
 
 QMAKE_OPTS = DEFINES+=NO_DEBUG_ON_CONSOLE
 MAKE_OPTS  = QMAKE=qmake-qt5 LRELEASE=lrelease-qt5 QMAKE_OPTS="$(QMAKE_OPTS)"
@@ -8,8 +9,9 @@
 	rm -f src/translations/*.qm
 
 override_dh_auto_build:
-	lupdate custom-toolbox.pro
-	lrelease custom-toolbox.pro
+	lupdate src.pro
+	lrelease src.pro
+	head -n1 debian/changelog | sed -e "s/.*(\([^(]*\)).*/#define VERSION \"\1\"/" > version.h
 	dh_auto_build -- $(MAKE_OPTS)
 
 override_dh_auto_install:

## custom-toolbox 0.20.11

=== debian/changelog ===
custom-toolbox (0.20.11) mx; urgency=medium

  * faster startup
  * removed mx-pkexec dependency
  * display minimize/maximize windows buttons

 -- Adrian <adrian@mxlinux.org>  Mon, 23 Nov 2020 19:17:51 -0500

## custom-toolbox 0.21.1

=== debian/changelog ===
custom-toolbox (0.21.1) mx; urgency=medium

  * remove disown which is not present in sh
  * root guard (shouldn't start when somebody logs in a root)

 -- Adrian <adrian@mxlinux.org>  Sun, 24 Jan 2021 13:33:54 -0500

=== debian/control ===
--- 
+++ 
@@ -8,6 +8,6 @@
 
 Package: custom-toolbox
 Architecture: any
-Depends: mx-pkexec, ${misc:Depends}, ${shlibs:Depends}
+Depends: menu, ${misc:Depends}, ${shlibs:Depends}
 Description: Custom Toolbox
  Custom Toolbox is a tool used for creating collections of icons

=== debian/rules ===
--- 
+++ 
@@ -9,8 +9,8 @@
 	rm -f src/translations/*.qm
 
 override_dh_auto_build:
-	lupdate src.pro
-	lrelease src.pro
+	lupdate custom-toolbox.pro
+	lrelease custom-toolbox.pro
 	head -n1 debian/changelog | sed -e "s/.*(\([^(]*\)).*/#define VERSION \"\1\"/" > version.h
 	dh_auto_build -- $(MAKE_OPTS)

## custom-toolbox 0.21.7.01

=== debian/changelog ===
custom-toolbox (0.21.7.01) mx; urgency=medium

  * Try to return icon fromTheme first

 -- Adrian <adrian@mxlinux.org>  Mon, 19 Jul 2021 09:27:22 -0400

custom-toolbox (0.21.7) mx; urgency=medium

  * Preserve order from list when adding buttons
  * Add "alias" option to change displayed name of program, format: alias 'new name'
  * Don't ask for root access if .list file is editable by user
  * Faster icon search
  * Save config file under ~/.config/MX-Linux

 -- Adrian <adrian@mxlinux.org>  Mon, 19 Jul 2021 02:11:59 -0400

## custom-toolbox 0.21.7.02

=== debian/changelog ===
custom-toolbox (0.21.7.02) mx; urgency=medium

  * Add Theme= option in .list to load a specific icon theme

 -- Adrian <adrian@mxlinux.org>  Tue, 20 Jul 2021 00:43:01 -0400

## custom-toolbox 0.21.8

=== debian/changelog ===
custom-toolbox (0.21.8) mx; urgency=medium

  * Added a "remove-checkbox" start option to remove "show this dialog at startup" checkbox

 -- Adrian <adrian@mxlinux.org>  Sat, 21 Aug 2021 00:33:52 -0400

## custom-toolbox 0.21.8.01

=== debian/changelog ===
custom-toolbox (0.21.8.01) mx; urgency=medium

  * Make it possible to add options before the .list file name when starting from CLI

 -- Adrian <adrian@mxlinux.org>  Mon, 23 Aug 2021 17:14:22 -0400

## custom-toolbox 0.21.8.02

=== debian/changelog ===
custom-toolbox (0.21.8.02) mx; urgency=medium

  * Update icon layout on window resize
  * Icon size can be set in /etc/custom-toolbox/custom-toolbox.conf
  * Use native formate for .conf file

 -- Adrian <adrian@mxlinux.org>  Thu, 26 Aug 2021 23:07:58 -0400

## custom-toolbox 0.21.9

=== debian/changelog ===
custom-toolbox (0.21.9) mx; urgency=medium

  * Fix applying min width specified in .conf file

 -- Adrian <adrian@mxlinux.org>  Mon, 06 Sep 2021 01:50:05 -0400

## custom-toolbox 0.21.10

=== debian/changelog ===
custom-toolbox (0.21.10) mx; urgency=medium

  * Added a "fixed_number_columns" property in .conf file
  * this is used to set a non-resizable window with the buttons
  * arranged in that specific number of columns
  * e.g., use "fixed_number_columns=3" to display buttons in 3 columns

 -- Adrian <adrian@mxlinux.org>  Wed, 06 Oct 2021 17:11:58 -0400

## custom-toolbox 0.22.2

=== debian/changelog ===
custom-toolbox (0.22.2) mx; urgency=medium

  * Fix: show app after editing a .list file
  * Improving editor selection

 -- Adrian <adrian@mxlinux.org>  Wed, 09 Feb 2022 22:25:53 -0500

=== debian/rules ===
--- 
+++ 
@@ -17,11 +17,8 @@
 override_dh_auto_install:
 	dh_auto_install -- $(MAKE_OPTS)
 
-override_dh_builddeb:
-	dh_builddeb -- -Z xz
-
 override_dh_shlibdeps:
 	dh_shlibdeps --dpkg-shlibdeps-params=--ignore-missing-info
 
 %:
-	dh $@ --parallel 
+	dh $@ --no-automatic-dbgsym --parallel

## custom-toolbox 0.23.4

=== debian/changelog ===
custom-toolbox (0.23.4) mx; urgency=medium

  * Update translations
  * Some performance fixes

 -- Adrian <adrian@mxlinux.org>  Sat, 29 Apr 2023 18:01:10 -0400

## custom-toolbox 0.23.5

=== debian/changelog ===
custom-toolbox (0.23.5) mx; urgency=medium

  * New logo

 -- Adrian <adrian@mxlinux.org>  Tue, 16 May 2023 21:21:57 -0400

## custom-toolbox 0.23.6

=== debian/changelog ===
custom-toolbox (0.23.6) mx; urgency=medium

  * Minor optimization
  * Refresh translations

 -- Adrian <adrian@mxlinux.org>  Thu, 08 Jun 2023 23:27:35 -0400

## custom-toolbox 23.6

=== debian/changelog ===
custom-toolbox (23.6) mx; urgency=medium

  * Run featherpad as normal user (featherpad will elevate itself)
  * Use pkexec instead of su-to-root

 -- Adrian <adrian@mxlinux.org>  Sun, 18 Jun 2023 11:01:24 -0400

## custom-toolbox 23.7

=== debian/changelog ===
custom-toolbox (23.7) mx; urgency=medium

  * Localize name and comment of the toolbox

 -- Adrian <adrian@mxlinux.org>  Sun, 16 Jul 2023 22:39:07 -0400

custom-toolbox (23.6.01) mx; urgency=medium

  * Make sure no button is autoselected

 -- Adrian <adrian@mxlinux.org>  Sat, 24 Jun 2023 09:32:24 -0400

## custom-toolbox 23.7.01

=== debian/changelog ===
custom-toolbox (23.7.01) mx; urgency=medium

  * Fix language detection 

 -- Adrian <adrian@mxlinux.org>  Mon, 17 Jul 2023 00:40:57 -0400

=== debian/rules ===
--- 
+++ 
@@ -11,7 +11,7 @@
 override_dh_auto_build:
 	lupdate custom-toolbox.pro
 	lrelease custom-toolbox.pro
-	head -n1 debian/changelog | sed -e "s/.*(\([^(]*\)).*/#define VERSION \"\1\"/" > version.h
+	head -n1 debian/changelog | sed -e "s/.*(\([^(]*\)).*/const QString VERSION {\"\1\"};/" > version.h
 	dh_auto_build -- $(MAKE_OPTS)
 
 override_dh_auto_install:

## custom-toolbox 23.7.02

=== debian/changelog ===
custom-toolbox (23.7.02) mx; urgency=medium

  * Launch programs in background without locking the GUI

 -- Adrian <adrian@mxlinux.org>  Thu, 20 Jul 2023 00:26:45 -0400

## custom-toolbox 23.7.03

=== debian/changelog ===
custom-toolbox (23.7.03) mx; urgency=medium

  * Fix FR translation

 -- Adrian <adrian@mxlinux.org>  Thu, 20 Jul 2023 17:52:52 -0400

## custom-toolbox 23.7.04

=== debian/changelog ===
custom-toolbox (23.7.04) mx; urgency=medium

  * Add option to run a program as normal user even if starting custom-toolbox as root
     - to use this add "user" flag next to the name of the app in .list file

 -- Adrian <adrian@mxlinux.org>  Fri, 21 Jul 2023 16:35:00 -0400

## custom-toolbox 23.7.05

=== debian/changelog ===
custom-toolbox (23.7.05) mx; urgency=medium

  * Fix translations

 -- Adrian <adrian@mxlinux.org>  Sun, 23 Jul 2023 23:18:28 -0400

## custom-toolbox 23.7.06

=== debian/changelog ===
custom-toolbox (23.7.06) mx; urgency=medium

  * Fix comment translation

 -- Adrian <adrian@mxlinux.org>  Mon, 24 Jul 2023 12:48:46 -0400

## custom-toolbox 23.11

=== debian/changelog ===
custom-toolbox (23.11) mx; urgency=medium

  * update rules file
  * update translations
  * add arm64 build

 -- Dolphin Oracle <dolphinoracle@gmail.com>  Mon, 13 Nov 2023 19:36:57 -0500

=== debian/rules ===
--- 
+++ 
@@ -9,8 +9,8 @@
 	rm -f src/translations/*.qm
 
 override_dh_auto_build:
-	lupdate custom-toolbox.pro
-	lrelease custom-toolbox.pro
+	lupdate translations/*.ts
+	lrelease translations/*.ts
 	head -n1 debian/changelog | sed -e "s/.*(\([^(]*\)).*/const QString VERSION {\"\1\"};/" > version.h
 	dh_auto_build -- $(MAKE_OPTS)

## custom-toolbox 23.11.01

=== debian/changelog ===
custom-toolbox (23.11.01) mx; urgency=medium

  * Run commands in background and leave the UI active
  * More translations

 -- Adrian <adrian@mxlinux.org>  Mon, 13 Nov 2023 23:03:43 -0500

## custom-toolbox 24.3

=== debian/changelog ===
custom-toolbox (24.3) mx; urgency=medium

  * Update translations

 -- Adrian <adrian@mxlinux.org>  Sat, 23 Mar 2024 12:01:35 -0400

## custom-toolbox 24.5

=== debian/changelog ===
custom-toolbox (24.5) mx; urgency=medium

  * Fix launching some CLI tools
  * Update translations

 -- Adrian <adrian@mxlinux.org>  Sat, 11 May 2024 00:44:45 -0400

## custom-toolbox 24.5.01

=== debian/changelog ===
custom-toolbox (24.5.01) mx; urgency=medium

  * Faster icon search (reduces startup time)
  * Use utilities-terminal icon as backup for applications without icon

 -- Adrian <adrian@mxlinux.org>  Thu, 23 May 2024 22:28:39 -0400

## custom-toolbox 24.5.02

=== debian/changelog ===
custom-toolbox (24.5.02) mx; urgency=medium

  * Add Adwaita and scalable icon search paths
  * Cache utilities-terminal icon for subsequent use
  * Run editor in normal user if app is launched as root (if the editor
    elevates itself)

 -- Adrian <adrian@mxlinux.org>  Fri, 24 May 2024 10:31:46 -0400

## custom-toolbox 25.2

=== debian/changelog ===
custom-toolbox (25.2) mx; urgency=medium

  * Performance fixes
  * Update translations

 -- Adrian <adrian@mxlinux.org>  Mon, 03 Feb 2025 23:16:14 -0500

custom-toolbox (24.6) mx; urgency=medium

  * Update translations

 -- Adrian <adrian@mxlinux.org>  Thu, 20 Jun 2024 19:08:50 -0400

=== debian/control ===
Source: custom-toolbox
Section: admin
Priority: optional
Maintainer: Adrian <adrian@mxlinux.org>
Build-Depends: debhelper (>=10), qtbase5-dev, qttools5-dev-tools
Standards-Version: 3.9.8
Vcs-Git: git://github.com/AdrianTM/custom-toolbox

Package: custom-toolbox
Architecture: any
Depends: menu, findutils, grep, ${misc:Depends}, ${shlibs:Depends}
Description: Custom Toolbox
 Custom Toolbox is a tool used for creating collections of icons

## custom-toolbox 25.08.3

=== debian/changelog ===
custom-toolbox (25.08.3) UNRELEASED; urgency=medium

  * Quit app completely when pressing exit

 -- Adrian <adrian@mxlinux.org>  Wed, 20 Aug 2025 21:47:53 -0400

custom-toolbox (25.08.2) mx; urgency=medium

  * Minor optimizations
  * Update translations

 -- Adrian <adrian@mxlinux.org>  Sun, 17 Aug 2025 11:04:53 -0400

custom-toolbox (25.4) mx; urgency=medium

  * Update to Qt6
  * Update translations

 -- Adrian <adrian@mxlinux.org>  Wed, 23 Apr 2025 21:24:08 -0400

## custom-toolbox 25.08.4

=== debian/changelog ===
custom-toolbox (25.08.4) mx; urgency=medium

  * Fix Edit button: run edit command in a shell to process env variables

 -- Adrian <adrian@mxlinux.org>  Thu, 21 Aug 2025 08:40:18 -0400

custom-toolbox (25.08.3) mx; urgency=medium

  * Quit app completely when pressing exit

 -- Adrian <adrian@mxlinux.org>  Wed, 20 Aug 2025 21:47:53 -0400

## custom-toolbox 25.11

=== CMakeLists.txt ===
--- 
+++ 
@@ -22,6 +22,14 @@
 
 cmake_minimum_required(VERSION 3.16)
 
+# Option to use clang for testing builds - needs to be early so project() picks it up
+option(USE_CLANG "Use clang compiler" OFF)
+if(USE_CLANG)
+    set(CMAKE_C_COMPILER clang CACHE STRING "C compiler" FORCE)
+    set(CMAKE_CXX_COMPILER clang++ CACHE STRING "C++ compiler" FORCE)
+    message(STATUS "Using clang compiler")
+endif()
+
 # Get version from debian/changelog
 execute_process(
     COMMAND dpkg-parsechangelog -SVersion
@@ -31,8 +39,10 @@
     RESULT_VARIABLE DPKG_RESULT
 )
 
-if(NOT DPKG_RESULT EQUAL 0)
-    message(FATAL_ERROR "Failed to get version from debian/changelog using dpkg-parsechangelog")
+# Fallback to a safe default when changelog parsing is unavailable
+if(NOT DPKG_RESULT EQUAL 0 OR PROJECT_VERSION_FROM_CHANGELOG STREQUAL "")
+    message(WARNING "Falling back to version 0.0.0 (dpkg-parsechangelog not available or failed)")
+    set(PROJECT_VERSION_FROM_CHANGELOG "0.0.0")
 endif()
 
 project(custom-toolbox
@@ -59,12 +69,8 @@
 endif()
 
 # Option to use clang for testing builds
-option(USE_CLANG "Use clang compiler" OFF)
 if(USE_CLANG)
-    set(CMAKE_C_COMPILER clang)
-    set(CMAKE_CXX_COMPILER clang++)
     set(CMAKE_CXX_COMPILER_ID "Clang")
-    message(STATUS "Using clang compiler")
 endif()
 
 # Find Qt6 components
@@ -142,6 +148,7 @@
 target_compile_definitions(custom-toolbox PRIVATE
     QT_DEPRECATED_WARNINGS
     QT_DISABLE_DEPRECATED_BEFORE=0x060000
+    VERSION="${PROJECT_VERSION}"
 )
 
 # Release-specific optimizations
@@ -162,14 +169,8 @@
 # Handle translations
 qt6_add_translations(custom-toolbox
     TS_FILES ${TRANSLATION_FILES}
+    LRELEASE_OPTIONS -compress -nounfinished -removeidentical -silent
     QM_FILES_OUTPUT_VARIABLE qm_files
-)
-
-# Generate version.h file
-configure_file(
-    "${CMAKE_SOURCE_DIR}/src/version.h.in"
-    "${CMAKE_BINARY_DIR}/src/version.h"
-    @ONLY
 )
 
 # Set target properties
@@ -178,9 +179,6 @@
     RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}
 )
 
-# Add build directory to include path for generated version.h
-target_include_directories(custom-toolbox PRIVATE ${CMAKE_BINARY_DIR}/src)
-
 # Install target (required by Debian build system)
 # Other files are handled by debian/install
 install(TARGETS custom-toolbox

=== debian/changelog ===
custom-toolbox (25.11) mx; urgency=medium

  * Adjust the root-home detection in displayDoc() to compare the canonical path against /root, so the original HOME is restored when the app was launched as root.
  * Clear icon_theme at the top of MainWindow::readFile() so theme settings don’t persist after removing the Theme= line in a .list
  * Add an early guard to bail out when a button’s command string is empty so we don’t crash on QProcess::splitCommand
  * Add file watcher to update UI when the .list file is changed
  * Fix various issues from codebase review

 -- Adrian <adrian@mxlinux.org>  Tue, 04 Nov 2025 14:29:15 -0500

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: admin
 Priority: optional
 Maintainer: Adrian <adrian@mxlinux.org>
-Build-Depends: debhelper (>=10), qtbase5-dev, qttools5-dev-tools
+Build-Depends: debhelper-compat (=12), cmake (>= 3.16), ninja-build, qt6-base-dev, qt6-base-dev-tools, qt6-tools-dev, qt6-tools-dev-tools
 Standards-Version: 3.9.8
 Vcs-Git: git://github.com/AdrianTM/custom-toolbox

## custom-toolbox 26.01

=== CMakeLists.txt ===
--- 
+++ 
@@ -21,6 +21,40 @@
 # **********************************************************************/
 
 cmake_minimum_required(VERSION 3.16)
+
+set(PROJECT_VERSION_FROM_CHANGELOG "")
+
+if(DEFINED PROJECT_VERSION_OVERRIDE AND NOT "${PROJECT_VERSION_OVERRIDE}" STREQUAL "")
+    set(PROJECT_VERSION_FROM_CHANGELOG "${PROJECT_VERSION_OVERRIDE}")
+    message(STATUS "Using version override: ${PROJECT_VERSION_FROM_CHANGELOG}")
+else()
+    # Try dpkg-parsechangelog first (Debian/Ubuntu)
+    execute_process(
+        COMMAND dpkg-parsechangelog -SVersion
+        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
+        OUTPUT_VARIABLE PROJECT_VERSION_FROM_CHANGELOG
+        OUTPUT_STRIP_TRAILING_WHITESPACE
+        RESULT_VARIABLE DPKG_RESULT
+        ERROR_QUIET
+    )
+
+    if(DPKG_RESULT EQUAL 0 AND NOT "${PROJECT_VERSION_FROM_CHANGELOG}" STREQUAL "")
+        message(STATUS "Using version from debian/changelog: ${PROJECT_VERSION_FROM_CHANGELOG}")
+    elseif(EXISTS ${CMAKE_SOURCE_DIR}/debian/changelog)
+        file(READ ${CMAKE_SOURCE_DIR}/debian/changelog PROJECT_CHANGELOG_CONTENT)
+        string(REGEX MATCH "^[^\\(]*\\(([^)]+)\\)" _match "${PROJECT_CHANGELOG_CONTENT}")
+        if(_match)
+            set(PROJECT_VERSION_FROM_CHANGELOG "${CMAKE_MATCH_1}")
+            message(STATUS "Using version parsed from debian/changelog: ${PROJECT_VERSION_FROM_CHANGELOG}")
+        else()
+            message(WARNING "Could not parse version from debian/changelog, defaulting to 0.0.0")
+            set(PROJECT_VERSION_FROM_CHANGELOG "0.0.0")
+        endif()
+    else()
+        message(WARNING "Could not determine version automatically, defaulting to 0.0.0")
+        set(PROJECT_VERSION_FROM_CHANGELOG "0.0.0")
+    endif()
+endif()
 
 # Option to use clang for testing builds - needs to be early so project() picks it up
 option(USE_CLANG "Use clang compiler" OFF)
@@ -28,21 +62,6 @@
     set(CMAKE_C_COMPILER clang CACHE STRING "C compiler" FORCE)
     set(CMAKE_CXX_COMPILER clang++ CACHE STRING "C++ compiler" FORCE)
     message(STATUS "Using clang compiler")
-endif()
-
-# Get version from debian/changelog
-execute_process(
-    COMMAND dpkg-parsechangelog -SVersion
-    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
-    OUTPUT_VARIABLE PROJECT_VERSION_FROM_CHANGELOG
-    OUTPUT_STRIP_TRAILING_WHITESPACE
-    RESULT_VARIABLE DPKG_RESULT
-)
-
-# Fallback to a safe default when changelog parsing is unavailable
-if(NOT DPKG_RESULT EQUAL 0 OR PROJECT_VERSION_FROM_CHANGELOG STREQUAL "")
-    message(WARNING "Falling back to version 0.0.0 (dpkg-parsechangelog not available or failed)")
-    set(PROJECT_VERSION_FROM_CHANGELOG "0.0.0")
 endif()
 
 project(custom-toolbox

=== debian/changelog ===
custom-toolbox (26.01) mx; urgency=medium

  * Don't freeze or hide interface (unless requested) when running programs that require elevation
  * Show empty results on search miss
  * Ensure autostart dir exists

 -- Adrian <adrian@mxlinux.org>  Tue, 06 Jan 2026 11:22:27 -0500

## custom-toolbox 26.02

=== CMakeLists.txt ===
--- 
+++ 
@@ -87,11 +87,6 @@
     endif()
 endif()
 
-# Option to use clang for testing builds
-if(USE_CLANG)
-    set(CMAKE_CXX_COMPILER_ID "Clang")
-endif()
-
 # Find Qt6 components
 find_package(Qt6 REQUIRED COMPONENTS
     Core
@@ -166,7 +161,6 @@
 # Set compile definitions
 target_compile_definitions(custom-toolbox PRIVATE
     QT_DEPRECATED_WARNINGS
-    QT_DISABLE_DEPRECATED_BEFORE=0x060000
     VERSION="${PROJECT_VERSION}"
 )

=== debian/changelog ===
custom-toolbox (26.02) mx; urgency=medium

  * Preserve default editor command flags when launching Edit
  * Improve default editor detection for terminal and self-elevating editors
  * Preserve the original HOME when opening docs from root sessions
  * Fix About -> Changelog so compressed changelog text displays correctly
  * Keep at least one button column in very narrow windows
  * Clear cached desktop entry lookups when reloading a .list file
  * Show clearer errors when commands fail to start
  * Apply the configured icon theme after loading each .list file
  * Fix FlatButton hover styling

 -- Adrian <adrian@mxlinux.org>  Sat, 21 Feb 2026 16:05:00 -0500
